<?php /*                                     * /
      $root='/cpmarchive';  /* for main site */
      $root='';             /* for local site */
      $sitevars=$root.'site/html/variables.php'; include $sitevars;
    ?>

<?php

	// MINIXED is a minimal but nice-looking PHP directory indexer.
	// More at https://github.com/lorenzos/Minixed

	// =============================
	// Configuration                
	// =============================
	
	// $browseDirectories = false; // Navigate into sub-folders
	$browseDirectories = true; // Navigate into sub-folders
	// $title = 'Index of {{path}}';
	$title = '{{path}}';
	$subtitle = '{{files}} objects in this folder, {{size}} total'; // Empty to disable
	$showParent = false; // Display a (parent directory) link
	$showDirectories = true;
	$showHiddenFiles = false; // Display files starting with "." too
	$alignment = 'left'; // You can use 'left' or 'center'
	$showIcons = false;
	// $dateFormat = 'd/m/y H:i'; // Used in date() function
	$dateFormat = 'y/m/d H:i'; // Used in date() function
	$sizeDecimals = 1;
	$robots = 'noindex, nofollow'; // Avoid robots by default
	$showFooter = false; // Display the "Powered by" footer
	$openIndex = $browseDirectories && true; // Open index files present in the current directory if browseDirectories is enabled
	
	// =============================
	// =============================
	
	// Who am I?
	$_self = basename($_SERVER['PHP_SELF']);
	$_path = str_replace('\\', '/', dirname($_SERVER['PHP_SELF']));
	$_total = 0;
	$_total_size = 0;
	
	// Directory browsing
	$_browse = null;
	if ($browseDirectories) {
		$_GET['b'] = trim(str_replace('\\', '/', $_GET['b']), '/ ');
		$_GET['b'] = str_replace(array('/..', '../'), '', $_GET['b']); // Avoid going up into filesystem
		if (!empty($_GET['b']) && $_GET['b'] != '..' && is_dir($_GET['b'])) $_browse = $_GET['b'];
	}
	
	// Index open
	if (!empty($_browse) && $openIndex) {
		$_index = null;
		if (file_exists($_browse . "/index.htm")) $_index = "/index.htm";
		if (file_exists($_browse . "/index.html")) $_index = "/index.html";
		if (file_exists($_browse . "/index.php")) $_index = "/index.php";
		if (!empty($_index)) {
			header('Location: ' . $_browse . $_index);
			exit();
		}
	}

	// Encoded images generator
	if (!empty($_GET['i'])) {
		header('Content-type: image/png');
		switch ($_GET['i']) {
			case       'asc': exit(base64_decode('iVBORw0KGgoAAAANSUhEUgAAAAcAAAAHCAYAAADEUlfTAAAAFUlEQVQImWNgoBT8x4JxKsBpAhUAAPUACPhuMItPAAAAAElFTkSuQmCC'));
			case      'desc': exit(base64_decode('iVBORw0KGgoAAAANSUhEUgAAAAcAAAAHCAYAAADEUlfTAAAAF0lEQVQImWNgoBb4j0/iPzYF/7FgCgAADegI+OMeBfsAAAAASUVORK5CYII='));
			case 'directory': exit(base64_decode('iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAASklEQVQYlYWPwQ3AMAgDb3Tv5AHdR5OqTaBB8gM4bAGApACPRr/XuujA+vqVcAI3swDYjqRSH7B9oHI8grbTgWN+g3+xq0k6TegCNtdPnJDsj8sAAAAASUVORK5CYII='));
			case      'file': exit(base64_decode('iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAPklEQVQYlcXQsQ0AIAhE0b//GgzDWGdjDCJoKck13CsIALi7gJxyVmFmyrsXLHEHD7zBmBbezvoJm4cL0OwYouM4O3J+UDYAAAAASUVORK5CYII='));
		}
	}
	
	// I'm not sure this function is really needed...
	function ls($path, $show_folders = false, $show_hidden = false) {
		global $_self, $_total, $_total_size;
		$ls = array();
		$ls_d = array();
		if (($dh = @opendir($path)) === false) return $ls;
		if (substr($path, -1) != '/') $path .= '/';
		while (($file = readdir($dh)) !== false) {
			if ($file == $_self) continue;
			if ($file == '.' || $file == '..') continue;
			if (!$show_hidden) if (substr($file, 0, 1) == '.') continue;
			$isdir = is_dir($path . $file);
			if (!$show_folders && $isdir) continue;
			$item = array('name' => $file, 'isdir' => $isdir, 'size' => $isdir ? 0 : filesize($path . $file), 'time' => filemtime($path . $file));
			if ($isdir) $ls_d[] = $item; else $ls[] = $item;
			$_total++;
			$_total_size += $item['size'];
		}
		return array_merge($ls_d, $ls);
	}
	
	// Get the list of files
	$items = ls('.' . (empty($_browse) ? '' : '/' . $_browse), $showDirectories, $showHiddenFiles);
	
	// Sort it
	function sortByName($a, $b) { return ($a['isdir'] == $b['isdir'] ? strtolower($a['name']) > strtolower($b['name']) : $a['isdir'] < $b['isdir']); }
	function sortBySize($a, $b) { return ($a['isdir'] == $b['isdir'] ? $a['size'] > $b['size'] : $a['isdir'] < $b['isdir']); }
	function sortByTime($a, $b) { return ($a['time'] > $b['time']); }
	switch (@$_GET['s']) {
		case 'size': $_sort = 'size'; usort($items, 'sortBySize'); break;
		case 'time': $_sort = 'time'; usort($items, 'sortByTime'); break;
		default    : $_sort = 'name'; usort($items, 'sortByName'); break;
	}
	
	// Reverse?
	$_sort_reverse = (@$_GET['r'] == '1');
	if ($_sort_reverse) $items = array_reverse($items);
	
	// Add parent
	if ($showParent && $_path != '/' && empty($_browse)) array_unshift($items, array(
		'name' => '..',
		'isparent' => true,
		'isdir' => true,
		'size' => 0,
		'time' => 0
	));

	// Add parent in case of browsing a sub-folder
	if (!empty($_browse)) array_unshift($items, array(
		'name' => '..',
		'isparent' => false,
		'isdir' => true,
		'size' => 0,
		'time' => 0
	));
	
	// 37.6 MB is better than 39487001
	function humanizeFilesize($val, $round = 0) {
		$unit = array('','K','M','G','T','P','E','Z','Y');
		do { $val /= 1024; array_shift($unit); } while ($val >= 1000);
		return sprintf('%.'.intval($round).'f', $val) . ' ' . array_shift($unit) . 'B';
	}
	
	// Titles parser
	function getTitle($title) {
		global $_path, $_browse, $_total, $_total_size, $sizeDecimals;
		$path = $_path;
		if (!empty($_browse)) $path = $path . ($path != '/' ? '/' : '') . $_browse;
		return str_replace(array('{{path}}', '{{files}}', '{{size}}'), array($path, $_total, humanizeFilesize($_total_size, $sizeDecimals)), $title);
	}
	
	// Link builder
	function buildLink($changes) {
		global $_self;
		$params = $_GET;
		foreach ($changes as $k => $v) if (is_null($v)) unset($params[$k]); else $params[$k] = $v;
		foreach ($params as $k => $v) $params[$k] = urlencode($k) . '=' . urlencode($v);
		return empty($params) ? $_self : $_self . '?' . implode($params, '&');
	}

	function getDescriptionFile() { # Returns the path/name of the description file along with the column of the start of the description on each line in that file.
		if (stripos($_GET['b'], 'tel/sigm/') !== false ) { $f=substr($_GET['b'], 0, -15 ).'/sigm'.(substr($_GET['b'], -3, 1) + 1).'.idx'   ; if (file_exists($f)) return array($f,  0); }	# WalnutCD's SIG/M; use SIGMx.IDX; strip last 15 chars from path; use SIGMx.IDX, where "x" is +1 of volume hundreds digit; trailing slash in stripos match ensure we don't process the SIGM dir itself, where we want to use 00-index.txt instead. SIGMx.IDX is CSV, so startpos isn't used; just return 0.
		if (stripos($_GET['b'], 'pub/sigm/') !== false ) { $f=substr($_GET['b'], 0,  -7 ).'/sigm'.(substr($_GET['b'], -3, 1) + 1).'-fi.idx'; if (file_exists($f)) return array($f,  0); }	# OAK's rather than WalnutCD's SIG/M: strip last 7 chars from path
		if (stripos($_GET['b'], 'emon.com/') !== false ) { $f=       $_GET['b']          .'/00INDEX'                                       ; if (file_exists($f)) return array($f, 21); }	# demon.com collection
		if (stripos($_GET['b'], 'pub/cpmug') !== false ) { $f=       $_GET['b']          .'/cpmug-fi.idx'                                  ; if (file_exists($f)) return array($f,  0); }	# OAK's CPMUG collection, use cpmug-fi.idx
		if (stripos($_GET['b'],  'pub/cpm/') !== false ) { $f=       $_GET['b']          .'/00-index.txt'                                  ; if (file_exists($f)) return array($f, 31); }	# OAK's CPM collection, subdirs use local 00-index.txt
		if (stripos($_GET['b'],   'pub/cpm') !== false ) { $f=                            'cpm/Software/WalnutCD/cpm/00-index.txt'         ; if (file_exists($f)) return array($f, 31); }	# OAK's CPM collection, root dir uses 00-index.txt in WalnutCD's CPM/
		if (stripos($_GET['b'],     'rlee/') !== false ) { $f=                            'cpm/Software/rlee/00-index.txt'                 ; if (file_exists($f)) return array($f, 33); }	# RLee collection use rlee/00-index.txt
		                                                 { $f=       $_GET['b']          .'/dirs.txt'                                      ; if (file_exists($f)) return array($f, 33); }	# These two lines should be last as they're the defaults
		                                                 { $f=       $_GET['b']          .'/00-index.txt'                                  ; if (file_exists($f)) return array($f, 33);	}	# Look for "00-index.txt" in cur dir, return if found
		return array('No description file found', 0);	# if nothing found
	}

	function getDescription($searchterm,$descriptionfile,$startingposition) { #Parses $descriptionfile for $searchterm (the file name whose description we want) then extracts the tail of the line beginning at $startingposition
	      if (stripos($_GET['b'], 'trs80') !== false )         return '';				  # On the TRS80 side we want null returned; this causes the description column to collapse to 0, leaving max room for the long filenames there.
	      if ($descriptionfile == 'No description file found') return '&nbsp;';                       # There is no description file, so just return empty.
	      if ($searchterm == '..')                             return 'Parent dir';                   # Label the double-dot.
	      if (stripos($descriptionfile, '/rlee') !== false ) { $searchterm=$searchterm.'    '; }      # In the rlee dir, directory names are just a single letter; pad with spaces to prevent everything matching 
	      $dfile=file($descriptionfile);
	      foreach($dfile as $line_num => $currentline) {
		if (stripos($currentline, $searchterm) !== false )					# Looking for line with our filename in it.
		  {
		    if (stripos($currentline, 'No description available') == true )   return '&nbsp;';	# Decluttering: if description says "No description available" or ...
		    if (strlen($currentline) < ($startingposition + 3))               return '&nbsp;';	# ... line too short to to contain a description (+3 for cr/lf)
		    if (stripos($descriptionfile, 'sigm/s'   ) !== false ) return str_replace('"','',substr($currentline,strripos($currentline, '"', -3)));	# Get tail of $currentline beginning at 2nd-to-last quotation mark (-3 skips very last), strip all '"'
		    if (stripos($descriptionfile, 'pub/cpmug') !== false ) return str_replace('"','',substr($currentline,strripos($currentline, '"', -3)));	# Get tail of $currentline beginning at 2nd-to-last quotation mark (-3 skips very last), strip all '"'
		    
		    return substr($currentline, $startingposition);					# Default if none of the above.
		  } # if stripos
	        } # foreach loop
	      return '&nbsp;';
	}

?>
<!DOCTYPE HTML>
<html lang="en-US">
<head>
  <meta charset="UTF-8">
  <meta name="robots" content="<?php echo htmlentities($robots) ?>">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <title><?php echo htmlentities(getTitle($title)) ?></title>
	
  <style type="text/css">

	* { margin: 0; padding: 0; border: none; }

	body {
	font-family: computer1, courier new, LucidaTerminal, monospace;
	color: #0f0;
	background-color:#000; 
	text-align: left;
	font-size: 12pt; 	/* Dunno why but this ends up controlling the line spacing w/o changing the actual font size */	
	/*	text-align: center;
	font-family: sans-serif;
	font-size: 13px;
	color: #000000;
	*/}

	a, a:visited {   
        /* color:#0a4 
	color: yellow;
        border-bottom: solid 1px #0f0;
        text-decoration: none;
        text-decoration: underline; 
        text-transform: uppercase;
        font-weight: bold; */
        text-decoration: none;
        padding-bottom: 2px;
        /* border-bottom: dashed 1px; */
	color: #0f0;
	background-color:#000; 
	font-weight: bold;
        line-height: 100%;
	}

	a:hover { /* inherit everything from a -- just reverse colors */
        border-color: #0f0;
        background-color:#0f0;
        color: #000;
        }

	#wrapper {
	max-width: 800px;
	*width: 800px;
	margin: 0 auto;
	text-align: left;
	}
		
	body#left { text-align: left; }

	body#left #wrapper { margin: 0 20px; }
		
	h1 {
	font-size: 21px;
	padding: 0 10px;
	margin: 20px 0 0;
	font-weight: bold;
	background: #060;
	color: #ff0;
	text-shadow: 2px 2px #222;
	border-radius: 6px;
	box-shadow:                              /* This provides the beveled effect */
	  0 1px 2px #444,                        /*bottom external highlight*/
	  0 -1px 1px #444,                       /*top external shadow*/ 
	  inset 0 -1px 1px rgba(0,0,0,0.5),      /*bottom internal shadow*/ 
	  inset 0 1px 1px rgba(255,255,255,0.8); /*top internal highlight*/
	}
		
	h2 {                             /* xxx objects in this folder, xx.x GB total */
	font-size: 14px;
	padding: 0 10px;
	margin: 10px 0 0;
	color: #999999;
	font-weight: normal;
	}

	a { text-decoration: none; }
		
	ul#header {	
	margin-top: 20px;
	background: #000;
	color: #0f0;
	}
		
	ul li {
	display: block;
	list-style-type: none;
	overflow: hidden;
	padding: 1px;
	}
		
	ul li:hover {
	/* background-color: #f3f3f3;
	background-color: #0f0;
	color: #000; */
	}
		
	ul li .date {
	text-align: left;
	width: 520px;
	font-size: 16px;
	padding-left: 10px;
	}
		
	ul li .size {
	text-align: right;
	width: 90px;
	font-size: 12px;
	}
		
	ul li .date, ul li .size { /* "Last modified" and "Size" columns */
	float: right;
	display: block;
	color: #666666;
	}
		
	ul#header li {
	font-size: 11px;
	font-weight: bold;
	/* border-bottom: 1px solid #cccccc; */
	}

	ul#header li:hover { background-color: transparent; }
		
	ul#header li * {                     /* "Name - Last modified - size" line */
	color: #000000;
	font-size: 14px;
	background: #000; color: #0F0;
	}

	ul#header li a:hover { color: #666666; }

	ul#header li .asc span, ul#header li .desc span {
	padding-right: 15px;
	background-position: right center;
	background-repeat: no-repeat;
	}

	ul#header li .asc span { background-image: url('<?php echo $_self ?>?i=asc'); }

	ul#header li .desc span { background-image: url('<?php echo $_self ?>?i=desc'); }

	ul li.item { /* border-top: 1px solid #f3f3f3; */ }

	ul li.item:first-child { border-top: none; }
		
	ul li.item .name {
	/* color: #003399; */
	color: #0f0;
	font-weight: bold;
	}
		
	ul li.item .name:hover {
	/* color: #0066cc; */
	color: #000;
	background: #0f0;
	}

	ul li.item a:hover { /* text-decoration: underline; */ }
		
	ul li.item .directory, ul li.item .file { /* Text of items, name column only */
	padding-left: 20px;
	background-position: left center;
	background-repeat: no-repeat;
	font-size: 18px;
	}

	ul li.item .directory { background-image: url('<?php echo $_self ?>?i=directory'); }
		
	ul li.item .file {
	background-image: url('<?php echo $_self ?>?i=file');
	font-weight: normal;
	}
		
	#footer {
	font-size: 11px; text-shadow: 1px 1px #000;
	margin-top: 40px;
	margin-bottom: 20px;
	padding: 0 10px;
	clear:both; 
	border-radius: 6px;
	box-shadow:                              /* This provides the beveled effect */
	  0 1px 2px #444,                        /*bottom external highlight*/
	  0 -1px 1px #444,                       /*top external shadow*/ 
	  inset 0 -1px 1px rgba(0,0,0,0.5),      /*bottom internal shadow*/ 
	  inset 0 1px 1px rgba(255,255,255,0.8); /*top internal highlight*/
	text-align: center;
	background:#000; 
	/*background-color:#00a040;  */
	background: #060;
	color:#FFFFFF; 
	}

	#footer a { color: #cccccc; font-weight: bold; }

	#footer a:hover { color: #999999; }
		
  </style>
</head>

<body <?php if ($alignment == 'left') echo 'id="left"' ?>>

  <div id="wrapper">
    <h1><?php echo htmlentities(getTitle($title)) ?></h1>
    <h2><?php echo htmlentities(getTitle($subtitle)) ?></h2>

    <ul id="header">
      <li>
      <a href="<?php echo buildLink(array('s' => 'time', 'r' => (!$_sort_reverse && $_sort == 'time') ? '1' : null)) ?>" class="date <?php if ($_sort == 'time') echo $_sort_reverse ? 'desc' : 'asc' ?>"><span>Description</span></a>
      <a href="<?php echo buildLink(array('s' => 'size', 'r' => (!$_sort_reverse && $_sort == 'size') ? '1' : null)) ?>" class="size <?php if ($_sort == 'size') echo $_sort_reverse ? 'desc' : 'asc' ?>"><span>Size</span></a>
      <a href="<?php echo buildLink(array('s' =>  null , 'r' => (!$_sort_reverse && $_sort == 'name') ? '1' : null)) ?>" class="name <?php if ($_sort == 'name') echo $_sort_reverse ? 'desc' : 'asc' ?>"><span>Name</span></a>
      </li>
    </ul> <!-- header -->

    <ul>
	<?php list($DescFile, $StartPos) = getDescriptionFile(); ?> <!-- Name of description file and starting column of description passed back; list parses values into separate vars -->
        <?php foreach ($items as $item): ?>
	<li class="item">
	  <span class="date"><?php echo getDescription($item['name'],$DescFile,$StartPos); ?></span>
<!--	  <span class="date">< ?php echo (@$item['isparent'] || empty($item['time'])) ? '-' : date($dateFormat, $item['time']) ?></span>
-->	  <span class="size"><?php echo $item['isdir'] ? '[DIR]' : humanizeFilesize($item['size'], $sizeDecimals) ?></span>
	  <?php
	    if ($item['isdir'] && $browseDirectories && !@$item['isparent']) {
	      if ($item['name'] == '..') { $itemURL = buildLink(array('b' => substr($_browse, 0, strrpos($_browse, '/')))); } 
	        else { $itemURL = buildLink(array('b' => (empty($_browse) ? '' : (string)$_browse . '/') . $item['name']));}
	      } 
	     else { $itemURL = (empty($_browse) ? '' : (string)$_browse . '/') . $item['name']; }
	  ?>
	  <a href="<?php echo htmlentities($itemURL) ?>" class="name <?php if ($showIcons) echo $item['isdir'] ? 'directory' : 'file' ?>"><?php echo htmlentities($item['name']) . ($item['isdir'] ? ' /' : '') ?></a>
    	</li>

      <?php endforeach; ?>
    </ul>

    <?php if ($showFooter): ?><p id="footer">Powered by <a href="https://github.com/lorenzos/Minixed" target="_blank">Minixed</a>, a PHP directory indexer</p><?php endif; ?>
    <?php include $sitefooter; ?>

  </div> <!-- wrapper -->

</body>
</html>
